---
title: ExtendableEvent()
slug: Web/API/ExtendableEvent/ExtendableEvent
tags:
  - API
  - Constructor
  - Experimental
  - ExtendableEvent
  - Reference
  - Service Workers
  - ServiceWorker
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <code><strong>ExtendableEvent()</strong></code> constructor creates a new {{domxref("ExtendableEvent")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>extendableEvent</em> = new ExtendableEvent(<em>type</em>, <em>init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>The type of the ExtendableEvent, for example {{Event("install")}}, {{Event("activate")}}.</dd>
 <dt><code>init</code> {{optional_inline}}</dt>
 <dd>An options object containing any custom settings that you want to apply to the event object. Currently no possible options exist inside the spec, but this has been defined for forward compatibility across the different derived events.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-extendableevent-extendableevent', 'ExtendableEvent')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ExtendableEvent.ExtendableEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise")}}</li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using web workers</a></li>
</ul>
